`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    11:30:07 01/22/2021 
// Design Name: 
// Module Name:    SixteenSegment 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module SixteenSegment(oA1, oA2, oB, oC, oD1, oD2, oE, oF, oG1, oG2,
	oJ, oK, oL, oM, oN, oP, 
	oDis1, oDis2, oDis3, oDis4,
	iSw, iClk, iClkSwA, iClkSwB, iRst); 

	output oA1, oA2, oB, oC, oD1, oD2, oE, oF, oG1, oG2, oJ, oK, oL, oM, oN, oP;
	output oDis1, oDis2, oDis3, oDis4;
	
	input [5:0]iSw;
	input iClk, iClkSwA, iClkSwB, iRst;
	
	wire clkSw; // `^O菜XCb`̐M
	wire disClk; // fBXvCpNbN(4[kHz])
	wire [15:0]pattern; // XCb`͂ꂽ̂p^[
	wire [3:0]dis;
	
	reg [1:0]controlledDigit = 2'b11; // 삷錅D0:oDis1C1:oDis2, 2:oDis3, 3:oDis4
	
	
	assign {oDis4, oDis3, oDis2, oDis1} = dis;
	assign {oP, oN, oM, oL, oK, oJ, oG2, oG1, oF, oE, oD2, oD1, oC, oB, oA2, oA1} = pattern;

	AntiChattering U1(.iSig({iClkSwB, iClkSwA}), .oSig(clkSw));

	DividerForDisplay U2(.iClk(iClk), .oClk(disClk));
	SixteenSegmentController U3(.iClk(disClk), .iLoad(clkSw), 
		.iDigit(controlledDigit), .iSetPattern(iSw), .iRst(iRst),
		.oDis(dis),
		.oPattern(pattern));
	
	/* clkSw */
	always@(negedge clkSw or negedge iRst)
	begin
		if(iRst == 1'b0)
			controlledDigit <= 2'b11;
		else
			/* 삷錅ւ */
			controlledDigit <= controlledDigit + 2'b01;
	end

endmodule
