`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:14:31 01/23/2021 
// Design Name: 
// Module Name:    SevenSegmentController 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module SixteenSegmentController(iClk, iLoad, iDigit, iSetPattern, iRst, oDis, oPattern);
	input iClk; // NbN
	input iLoad; // 0Ȃp^[Zbg
	input [1:0]iDigit; // Zbg錅D0:oDis1C1:oDis2C2:oDis3C3:oDis4
	input [5:0]iSetPattern; // Zbgp^[
	input iRst;

	output [3:0]oDis;
	output [15:0]oPattern;
	
	reg [3:0]disDigit = 4'b1111; // Am[hɂPNPgWX^̃x[XQ
	reg [1:0]cnt = 2'b00; // _Ci~bN_邽߂̃JE^
	
	reg [5:0]dis1Pattern = 6'b111111;
	reg [5:0]dis2Pattern = 6'b111111;
	reg [5:0]dis3Pattern = 6'b111111;
	reg [5:0]dis4Pattern = 6'b111111;
	
	reg [15:0]oPattern = 16'b0000_0000_0000_0000;
	
	always@(posedge iClk)
	begin
		/* Zbg */
		if(iRst == 1'b0)
		begin
			dis1Pattern <= 6'b111111;
			dis2Pattern <= 6'b111111;
			dis3Pattern <= 6'b111111;
			dis4Pattern <= 6'b111111;
			cnt <= 2'b00;
			disDigit <= 4'b1111;
		end
		/* p^[[h */
		else if(iLoad == 1'b0)
		begin
			// p^[Zbg
			case(iDigit)
			2'b00:dis1Pattern <= iSetPattern;
			2'b01:dis2Pattern <= iSetPattern;
			2'b10:dis3Pattern <= iSetPattern;
			2'b11:dis4Pattern <= iSetPattern;
			endcase
		end
		case(cnt)
		2'b00:begin
			oPattern <= decoder(dis1Pattern);
			disDigit <= 4'b1110;
			cnt <= 2'b01;
		end
		2'b01:begin
			oPattern <= decoder(dis2Pattern);
			disDigit <= 4'b1101;
			cnt <= 2'b10;
		end
		2'b10:begin
			oPattern <= decoder(dis3Pattern);
			disDigit <= 4'b1011;
			cnt <= 2'b11;
		end
		2'b11:begin
			oPattern <= decoder(dis4Pattern);
			disDigit <= 4'b0111;
			cnt <= 2'b00;
		end
		endcase
	end
	

	// NbNLow̎ɂDIS1111ɁCHigĥƂɂdisDigitɂ
	assign oDis = (iClk==1'b0 ? 4'b1111 : disDigit);

	function [15:0]decoder;
		input [5:0]characterCode;
	begin
		case(characterCode)
			//                    PNM_LKJ_G2G1_F_E_D2D1_C_B_A2A1
			6'b000000:decoder=16'b000_000___11_1_1___00_1_1___11; // A
			6'b000001:decoder=16'b010_010___10_0_0___11_1_1___11; // B
			6'b000010:decoder=16'b000_000___00_1_1___11_0_0___11; // C
			6'b000011:decoder=16'b010_010___00_0_0___11_1_1___11; // D
			6'b000100:decoder=16'b000_000___11_1_1___11_0_0___11; // E 
			6'b000101:decoder=16'b000_000___11_1_1___00_0_0___11; // F
			6'b000110:decoder=16'b000_000___10_1_1___11_1_0___11; // G
			6'b000111:decoder=16'b000_000___11_1_1___00_1_1___00; // H
			6'b001000:decoder=16'b010_010___00_0_0___11_0_0___11; // I
			6'b001001:decoder=16'b000_000___00_0_1___11_1_1___10; // J
			6'b001010:decoder=16'b001_100___01_1_1___00_0_0___00; // K
			6'b001011:decoder=16'b000_000___00_1_1___11_0_0___00; // L
			6'b001100:decoder=16'b000_101___00_1_1___00_1_1___00; // M
			6'b001101:decoder=16'b001_001___00_1_1___00_1_1___00; // N
			6'b001110:decoder=16'b000_000___00_1_1___11_1_1___11; // O
			6'b001111:decoder=16'b000_000___11_1_1___00_0_1___11; // P
			6'b010000:decoder=16'b001_000___00_1_1___11_1_1___11; // Q
			6'b010001:decoder=16'b001_000___11_1_1___00_0_1___11; // R
			6'b010010:decoder=16'b001_001___00_0_0___11_0_0___11; // S
			6'b010011:decoder=16'b010_010___00_0_0___00_0_0___11; // T
			6'b010100:decoder=16'b000_000___00_1_1___11_1_1___00; // U
			6'b010101:decoder=16'b100_100___00_1_1___00_0_0___00; // V
			6'b010110:decoder=16'b101_000___00_1_1___00_1_1___00; // W
			6'b010111:decoder=16'b101_101___00_0_0___00_0_0___00; // X
			6'b011000:decoder=16'b010_101___00_0_0___00_0_0___00; // Y
			6'b011001:decoder=16'b100_100___00_0_0___11_0_0___11; // Z
			6'b100000:decoder=16'b110_000___01_0_0___01_0_0___00; // a
			6'b100001:decoder=16'b010_000___01_1_1___01_0_0___00; // b
			6'b100010:decoder=16'b000_000___01_0_1___01_0_0___00; // c
			6'b100011:decoder=16'b010_010___01_0_1___01_0_0___00; // d
			6'b100100:decoder=16'b100_000___01_0_1___01_0_0___00; // e 
			6'b100101:decoder=16'b010_010___11_0_0___00_0_0___10; // f
			6'b100110:decoder=16'b110_010___01_1_0___01_0_0___01; // g
			6'b100111:decoder=16'b010_000___01_1_1___00_0_0___00; // h
			6'b101000:decoder=16'b010_000___00_0_0___00_0_0___00; // i
			6'b101001:decoder=16'b000_000___00_0_0___10_1_1___00; // j
			6'b101010:decoder=16'b011_110___00_0_0___00_0_0___00; // k
			6'b101011:decoder=16'b000_000___00_1_1___01_0_0___00; // l
			6'b101100:decoder=16'b010_000___11_0_1___00_1_0___00; // m
			6'b101101:decoder=16'b010_000___01_0_1___00_0_0___00; // n
			6'b101110:decoder=16'b010_000___01_0_1___01_0_0___00; // o
			6'b101111:decoder=16'b000_010___01_1_1___00_0_0___01; // p
			6'b110000:decoder=16'b010_010___01_1_0___00_0_0___01; // q
			6'b110001:decoder=16'b000_000___01_0_1___00_0_0___00; // r
			6'b110010:decoder=16'b001_000___10_0_0___10_0_0___00; // s
			6'b110011:decoder=16'b010_010___11_0_0___10_0_0___00; // t
			6'b110100:decoder=16'b010_000___00_0_1___01_0_0___00; // u
			6'b110101:decoder=16'b100_000___00_0_1___00_0_0___00; // v
			6'b110110:decoder=16'b010_000___00_0_1___11_1_0___00; // w
			6'b110111:decoder=16'b010_000___11_0_0___11_0_0___00; // x
			6'b111000:decoder=16'b010_010___01_1_0___01_0_0___00; // y
			6'b111001:decoder=16'b100_000___01_0_0___01_0_0___00; // z
			6'b011010:decoder=16'b100_100___00_1_1___11_1_1___11; // 0
			6'b011011:decoder=16'b000_000___00_0_0___00_1_1___00; // 1
			6'b011100:decoder=16'b000_000___11_0_1___11_0_1___11; // 2
			6'b011101:decoder=16'b000_000___11_0_0___11_1_1___11; // 3
			6'b011110:decoder=16'b000_000___11_1_0___00_1_1___00; // 4
			6'b111010:decoder=16'b000_000___11_1_0___11_1_0___11; // 5
			6'b111011:decoder=16'b000_000___11_1_1___11_1_0___11; // 6
			6'b111100:decoder=16'b000_000___00_1_0___00_1_1___11; // 7
			6'b111101:decoder=16'b000_000___11_1_1___11_1_1___11; // 8
			6'b111110:decoder=16'b000_000___11_1_0___11_1_1___11; // 9
			6'b111111:decoder=16'b000_000___00_0_0___00_0_0___00; // 
			default:  decoder=16'bXXX_XXX___XX_X_X___XX_X_X___XX; // ???
		endcase
	end
	endfunction


endmodule
